var Blockchain = require('cb-blockr')
var DataLoader = require('chainloader')
var Keeper = require('bitkeeper-client-js')
var keeperConf = require('../conf/config').keeper
var Identity = require('midentity').Identity
var bitcoin = require('bitcoinjs-lib')
var once = require('once')

function getIdentity (txId, cb) {
  cb = once(cb)
  var networkName = 'testnet'
  var blockchain = new Blockchain(networkName)
  blockchain.transactions.get([txId], function (err, txs, metadata) {
    if (err) return cb(err)

    var tx = bitcoin.Transaction.fromHex(txs[0].txHex)
    var loader = new DataLoader({
      prefix: 'tradle',
      networkName: networkName,
      keeper: new Keeper(keeperConf)
    })

    loader.load(tx)
      .finally(function () {
        cb(new Error('Identity not found'))
      })

    loader.on('file:public', function (info) {
      var file = info.file
      if (Buffer.isBuffer(file) || typeof file === 'string') file = JSON.parse(file)

      cb(null, new Identity(file))
    })
  })
}

// getIdentity('68634f7de0427143f670fba6fa902ef72f2add733f7ec0a917f5e4570d011123', function(err, identity) {
// getIdentity('9c8b5c00da8aa9b3dfebb4e682f6502d61be74202a2ff2eefd30c34f94873cff', function(err, identity) {
getIdentity('96d3692a6de004115c0ea035ebd74c46c6fda97674829684b67514e961d22d92', function (err, identity) {
  if (!err && identity) console.log(identity)
})
